;
; stacktor-base.scm
; stacktor
; 
; Created by Mark Fredrickson on 2008-02-18.
; Copyright 2008 Mark Fredrickson. All rights reserved.
;
; Non-syntax for the stacktor egg
;

(require-for-syntax 'stack)
(use stack)

;;; Run-time helper functions
(define (arity p) (- (length (procedure-information p)) 1))

;;; Stacktor types: words, procedures, values
(define (procedure->word p) 
  (let ((a (arity p)))
    (lambda (stk) (cond
      ((> (- a 1) (stack-depth stk)) (error "Insufficient stack depth for operation"))
      ((= 0 a) (stack-push! stk (p)))
      (else (stack-push! stk (apply p (stack-cut! stk 0 (- a 1)))))))))

(define (stacktor-wrap x)
  (cond ((word? x) (word-proc x))
        ((procedure? x) (procedure->word x))
        (else (lambda (stk) (stack-push! stk x)))))

;;; Helper functions for stack action
(define (push proc) (lambda () proc))

;;; Words
(define-record word proc)

