(use test)
(use stack)
  
(test-group "Arity Checking"
  (stacktor-procedure-shadow ; closely tied to this macro, if things start failng, check macro
    (test 2 (arity map))
    (test 1 (arity not))
    (test "arity of a parmeter should be zero" 0 (arity (make-parameter #f)))
    (test 2 (arity +))
    (test 2 (arity -))
    (test 2 (arity /))
    (test 2 (arity -))
    (test 1 (arity string->number))
    (test 1 (arity exact->inexact))
    (test 0 (arity argv)))
    (test 0 (arity chicken-version))) ; Is it worth having test cases for other procs? < > ... etc
  
(test-group "Local procedure shadowing"
  (test-assert (macro? 'stacktor-procedure-shadow)))
  
(test-group "begin-stack form"
  (test-assert (macro? 'begin-stack))
  (test "Returns a stack" #t (stack? (begin-stack chicken-version)))
  (test (chicken-version) (stack-pop! (begin-stack chicken-version)))
  (test "Pushing on literal values" '(stack (a b c) foo 3 2 1) 
    (begin-stack 1 2 3 'foo '(a b c)))
  (test '(stack 10) (begin-stack 2 8 +))
  (test '(stack (1 4 9)) (begin-stack '(1 2 3) (push (lambda (x) (* x x))) map))
  (test '(stack 6) (begin-stack '(1 2 3) 0 (push +) fold)))
  
(test-group "Words"
  (test-assert (procedure? (procedure->word map)))
  (test 1 (arity (procedure->word map)))
  (test-assert (word? (word chicken-version)))
  (test-assert (macro? 'define-word))
  (test-assert (begin (define-word test-word chicken-version) (word? test-word)))
  (test '(stack 10) (begin-stack 8 (word 2 +))))
  
